<template>
  <div>
    <el-breadcrumb separator=">">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="#">养老院管理</a>
      </el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="/base/watchInfo">老人手表管理</a>
      </el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider></el-divider>
    <!--
      要resetFields起作用，必须配置:model和prop
    -->
    <el-form
      ref="queryForm"
      inline
      class="demo-form-inline"
    >
      <el-form-item label="设备编号" prop="deviceNo">
        <el-input type="text" size="mini" v-model="queryModel.deviceNo" ></el-input>
      </el-form-item>
      <el-form-item label="设备别名" prop="aliasName">
        <el-input type="text" size="mini" v-model="queryModel.aliasName" ></el-input>
      </el-form-item>
      <el-form-item label="绑定人员" prop="personId">
        <el-input type="text" size="mini" v-model="queryModel.personId" ></el-input>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          size="mini"
          icon="ios-search"
          @click="changePage(1)"
          :loading="loading"
          >查询</el-button
        >&nbsp;
        <el-button
          type="info"
          size="mini"
          style="margin-left: 8px"
          @click="handleReset('queryForm')"
          >重置</el-button
        >&nbsp;
      </el-form-item>
    </el-form>
    <el-divider></el-divider>
    <el-row class="button-group">
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-circle-plus"
        @click="handleAdd"
        >新增</el-button
      >
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-circle-plus"
        :disabled="multipleSelection.length == 0"
        @click="handleBatchDelete"
        >删除选中项</el-button
      >
    </el-row>
    <el-table
      :data="tableData"
      style="min-height: 400px"
      v-loading="loading"
      stripe
      @sort-change="sortChange"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column prop="deviceNo" sort-by="device_no" label="设备编号" sortable="custom" width="180" ></el-table-column>
      <el-table-column prop="aliasName" sort-by="alias_name" label="设备别名" sortable="custom" width="180" ></el-table-column>
      <el-table-column prop="personId" sort-by="person_id" label="绑定人员" sortable="custom" width="180" ></el-table-column>
      <el-table-column
        prop="heartBeatUpdateTime"
        sort-by="heart_beat_update_time"
        label="心跳更新时间"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column prop="isOnline" label="在线状态" width="100">
        <template slot-scope="{row}">
          <span v-if="row.isOnline" style="color:green;">在线</span>
          <span v-else>不在线</span>
        </template>
      </el-table-column>
      <!-- <el-table-column
        prop="sos1"
        sort-by="sos1"
        label="紧急联系人1号码"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="sos2"
        sort-by="sos2"
        label="紧急联系人2号码"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="sos3"
        sort-by="sos3"
        label="紧急联系人3号码"
        sortable="custom"
        width="180"
      ></el-table-column> -->
      <el-table-column
        prop="stepSwitch"
        sort-by="step_switch"
        label="计步器开关"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="locationTimeInterval"
        sort-by="location_time_interval"
        label="定位间隔时间"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="heartRateTimeInterval"
        sort-by="heart_rate_time_interval"
        label="心率间隔时间"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="bpi"
        sort-by="bpi"
        label="血压间隔时间"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="num1"
        sort-by="num1"
        label="服务号码"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="createTime"
        sort-by="create_time"
        label="创建时间"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="updateTime"
        sort-by="update_time"
        label="更新时间"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column label="操作" fixed="right" width="200">
        <template slot-scope="{row}">
          <el-link type="primary" :underline="false" @click="handleEdit(row)">编辑</el-link>-
          <el-link type="primary" :underline="false" @click="handleRemoteConfig(row)" :disabled="!row.isOnline">同步</el-link>-
          <el-link type="primary" :underline="false" @click="handleDelete(row)">删除</el-link>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      :current-page.sync="pageIndex"
      :total="totalElements"
      :page-sizes="pageSizeList"
      @current-change="changePage"
      @size-change="pageSizeChange"
      layout="total, sizes, prev, pager, next, jumper"
    ></el-pagination>
    <baseWatchInfo-detail
      v-if="showModal"
      :businessKey="businessKey"
      :title="modalTitle"
      @close="onDetailModalClose"
    ></baseWatchInfo-detail>
  </div>
</template>
<script>
import Constant from "@/constant";
import BaseWatchInfoDetail from "./watchInfo-detail";
import baseWatchInfoApi from "@/api/base/watchInfo";
import NProgress from "nprogress"; // progress bar
import "nprogress/nprogress.css"; // progress bar style

export default {
  name: 'baseWatchInfoList',
  data() {
    var self = this;

    return {
      queryModel: {
        deviceNo: "",
        aliasName: ""
      },
      loading: false,
      tableData: [],
      pageIndex: 1,
      pageSize: 10,
      totalPages: 0,
      totalElements: 0,
      field: "",
      direction: "",
      pageSizeList: [10, 20, 30],
      multipleSelection: [],
      showModal: false,
      modalTitle: "",
      businessKey: "",
    };
  },
  methods: {
    changePage(pageIndex) {
      var self = this;

      self.loading = true;

      self.pageIndex = pageIndex;
      var formData = new FormData();

      formData.append("pageIndex", self.pageIndex);
      formData.append("pageSize", self.pageSize);

      formData.append("deviceNo", self.queryModel.deviceNo);
      formData.append("aliasName", self.queryModel.aliasName);
      formData.append("personId", self.queryModel.personId);

      if (this.field != null) {
        formData.append("field", this.field);
      }

      if (this.direction != null) {
        formData.append("direction", this.direction);
      }

      baseWatchInfoApi
        .pageList(formData)
        .then(function (response) {
          self.loading = false;

          var jsonData = response.data.data;

          self.tableData = jsonData.data;
          self.totalPages = jsonData.totalPages;
          self.totalElements = jsonData.recordsTotal;
        })
        .catch((error) => {
          self.loading = false;
          // self.$message.error(error + "");
        });
    },
    pageSizeChange(pageSize) {
      this.pageSize = pageSize;

      this.$nextTick(() => {
        this.changePage(this.pageIndex);
      });
    },
    sortChange(data) {
      this.field = data.column.field;
      this.direction = data.order == "ascending" ? "asc" : "desc";

      this.changePage(this.pageIndex);
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleReset(name) {
      this.$refs[name].resetFields();
    },
    handleAdd() {
      this.modalTitle = "新增";
      this.businessKey = "";
      this.showModal = true;
    },
    handleEdit(record) {
      this.modalTitle = "编辑";
      this.businessKey = record.id;
      this.showModal = true;
    },
    handleDelete(record) {
      var self = this;

      self
        .$confirm("是否确认删除?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
        .then(() => {
          baseWatchInfoApi.remove(record.id).then(function (response) {
            var jsonData = response.data;

            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: "删除成功!",
              });
            }
          });
        });
    },
    handleBatchDelete() {
      var self = this;

      var idList = this.multipleSelection.map((record) => {
        return record.id;
      });

      this.$confirm("是否确认删除选中项？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        baseWatchInfoApi.batchRemove(idList).then(function (response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!",
            });
          }
        });
      });
    },
    handleRemoteConfig(row) {
      var self = this;

      baseWatchInfoApi.remoteConfig(row.id)
      .then(function (response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.$message({
              type: "success",
              message: "指令发送成功!"
            });
          }
          else{
            self.$message({
              type: "warning",
              message: jsonData.message
            });
          }
        });
    },
    onDetailModalClose(refreshed) {
      //保存成功后回调
      this.showModal = false;

      if (refreshed) {
        this.changePage(this.pageIndex);
      }
    },
  },
  mounted: function () {
    this.changePage(1);
  },
  components: {
    "baseWatchInfo-detail": BaseWatchInfoDetail,
  },
};
</script>
<style lang="scss" scoped>
.el-breadcrumb {
  margin: 10px;
  line-height: 20px;
}

.el-divider {
  margin: 5px 0;
}

.demo-form-inline {
  margin-left: 10px;
  text-align: left;
}

.button-group {
  margin-left: 10px;
  text-align: left;
}
</style>